<script setup lang="ts">
import { STAGES } from "~/utils/types/phenotype";
import type { PhenotypeInput } from "~/utils/types/phenotype";

const props = defineProps<{ phenotype: PhenotypeInput }>();
const phenotype = computed(() => props.phenotype);

const emit = defineEmits<{
  (e: "update:phenotype", v: PhenotypeInput): void;
}>();

const updatePhenotype = (updatedProps: Partial<PhenotypeInput>) => {
  emit("update:phenotype", { ...phenotype.value, ...updatedProps });
};

const imageUrl = (imageFile: File) => URL.createObjectURL(imageFile);
const rules = {
  concentration: [(v: number) => v > 0 || "Concentration is invalid"],
  injectedStage: [(v: string) => !!v || "Injected stage is required"],
  injectedStrain: [(v: string) => !!v || "Injected strain is required"],
  description: [(v: string) => !!v || "Phenotype description is required"],
  numberOfAnimals: [
    (v: number) => !v || v > 0 || "Number of animals is invalid",
  ],
};
</script>

<template>
  <div class="pb-8">Enter below the information to describe one phenotype.</div>
  <InputLabel text="*Gene:" />
  <v-text-field :model-value="phenotype.gene" disabled />
  <InputLabel
    text="dsRNA:"
    help="The dsRNA injected into the animals to obtain the phenotype"
  />
  <PhenotypeDsRNAInput
    :model-value="phenotype.dsRNA"
    @update:modelValue="
      (dsRNA: PhenotypeInput['dsRNA']) => updatePhenotype({ dsRNA })
    "
  />
  <InputLabel text="*Concentration:" />
  <v-text-field
    :model-value="phenotype.concentration"
    type="number"
    suffix="ng/μl"
    :rules="rules.concentration"
    @update:modelValue="
      (concentration: string) => updatePhenotype({ concentration })
    "
  />
  <InputLabel text="*Injected stage:" />
  <v-select
    :model-value="phenotype.injectedStage"
    :items="STAGES"
    :rules="rules.injectedStage"
    @update:modelValue="
      (injectedStage: PhenotypeInput['injectedStage']) =>
        updatePhenotype({ injectedStage })
    "
  />
  <InputLabel text="*Injected strain:" />
  <v-text-field
    :model-value="phenotype.injectedStrain"
    :rules="rules.injectedStrain"
    placeholder="e.g. Ga-2, SB, vw, pearl, ..."
    @update:modelValue="
      (injectedStrain: PhenotypeInput['injectedStrain']) =>
        updatePhenotype({ injectedStrain })
    "
  />

  <InputLabel text="*Reference:" />
  <PhenotypeReferenceInput
    :model-value="phenotype.reference"
    @update:modelValue="
      (reference: PhenotypeInput['reference']) => updatePhenotype({ reference })
    "
  />
  <InputLabel text="*Phenotype description:" />
  <v-text-field
    :model-value="phenotype.description"
    :rules="rules.description"
    placeholder="e.g. head not present"
    @update:modelValue="
      (description: PhenotypeInput['description']) =>
        updatePhenotype({ description })
    "
  />
  <InputLabel text="*Affected structure:" />
  <PhenotypeStructureInput
    :model-value="phenotype.structure"
    @update:modelValue="
      (structure: PhenotypeInput['structure']) => updatePhenotype({ structure })
    "
  />
  <InputLabel text="Affected process:" />
  <v-text-field
    :model-value="phenotype.process"
    placeholder="e.g. head development"
    @update:modelValue="
      (process: PhenotypeInput['process']) => updatePhenotype({ process })
    "
  />
  <InputLabel
    text="*Penetrance:"
    help="What portion of analyzed specimen showed the phenotype"
  />
  <PhenotypePenetranceInput
    :model-value="phenotype.penetrance"
    @update:modelValue="
      (penetrance: PhenotypeInput['penetrance']) =>
        updatePhenotype({ penetrance })
    "
  />
  <InputLabel text="Number of animals analysed:" />
  <v-text-field
    :model-value="phenotype.numberOfAnimals"
    type="number"
    :rules="rules.numberOfAnimals"
    @update:modelValue="
      (numberOfAnimals: string) => updatePhenotype({ numberOfAnimals })
    "
  />
  <InputLabel text="Comment:" />
  <v-textarea
    :model-value="phenotype.comment"
    @update:modelValue="(comment: string) => updatePhenotype({ comment })"
  />
  <InputLabel text="Upload images:" help="You can upload multiple images" />
  <v-file-input
    :model-value="phenotype.imageFiles"
    multiple
    chips
    persistent-hint
    hint="Note: Only images that have not been previously published or for which the rights allow publication may be uploaded"
    single-line
    label="No images selected"
    @update:modelValue="
      (imageFiles: PhenotypeInput['imageFiles']) =>
        updatePhenotype({ imageFiles })
    "
  />
  <div v-if="(phenotype.imageFiles || []).length > 0" class="pl-10 mt-2">
    <template v-for="(imageFile, i) in phenotype.imageFiles" :key="i">
      <div class="d-inline-flex mr-2">
        <v-img :src="imageUrl(imageFile)" height="150" class="flex-grow-1" />
      </div>
    </template>
  </div>
</template>
